<script setup>
import { date } from 'alga-js'
import { toast } from 'bulma-toast'

const router = useRouter()
const route = useRoute()
const activeSave = useActiveSave()

definePageMeta({
  middleware: ['auth', 'org']
})

const lastRecord = ref({})
const form = ref({
  id: '',
  uid: '',
  client: '',
  clientId: '',
  organization: '',
  organizationId: '',
  name: '',
  description: '',
  isActive: true,
  validFrom: date.now('date'),
  isQuantityBased: false,
  isBPartnerFlatDiscount: false,
  flatDiscount: 0,
  cumulativeLevel: 'Line',
  cumulativeLevelId: 'L',
  discountType: 'Breaks',
  discountTypeId: 'B',
  processing: false,
  alert: {
    status: '',
    message: '',
    processing: false
  }
})

const retrieve = async () => {
  const res = await $fetch('/api/materials/discount-schemas/'+route.params.id, {
    headers: useRequestHeaders(['cookie'])
  })
  if(res) {
    form.value = {
      id: route.params.id,
      uid: res?.uid || '',
      client: res?.AD_Client_ID?.identifier || '',
      clientId: res?.AD_Client_ID?.id || '',
      organization: res?.AD_Org_ID?.identifier || '',
      organizationId: res?.AD_Org_ID?.id || '',
      name: res?.Name || '',
      description: res?.Description || '',
      isActive: res?.IsActive ?? true,
      validFrom: res?.ValidFrom || date.now('date'),
      isQuantityBased: res?.IsQuantityBased ?? false,
      isBPartnerFlatDiscount: res?.IsBPartnerFlatDiscount ?? false,
      flatDiscount: res?.FlatDiscount || 0,
      cumulativeLevel: res?.CumulativeLevel?.identifier || 'Line',
      cumulativeLevelId: res?.CumulativeLevel?.id || 'L',
      discountType: res?.DiscountType?.identifier || 'Breaks',
      discountTypeId: res?.DiscountType?.id || 'B',
      processing: false,
      alert: {
        status: '',
        message: '',
        processing: false
      }
    }
    lastRecord.value = res
    setNoEdit()
    activeSave.value = false
  }
}
onMounted(retrieve)

const noEdit = ref(true)
const setNoEdit = () => {
  noEdit.value = (
    form.value.organizationId == (lastRecord.value?.AD_Org_ID?.id || '') &&
    form.value.name == (lastRecord.value?.Name || '') &&
    form.value.description == (lastRecord.value?.Description || '') &&
    form.value.isActive == (lastRecord.value?.IsActive ?? true) &&
    form.value.validFrom == (lastRecord.value?.ValidFrom || date.now('date')) &&
    form.value.isQuantityBased == (lastRecord.value?.IsQuantityBased ?? false) &&
    form.value.isBPartnerFlatDiscount == (lastRecord.value?.IsBPartnerFlatDiscount ?? false) &&
    form.value.flatDiscount == (lastRecord.value?.FlatDiscount || 0) &&
    form.value.cumulativeLevel == (lastRecord.value?.CumulativeLevel?.identifier || 'Line') &&
    form.value.cumulativeLevelId == (lastRecord.value?.CumulativeLevel?.id || 'L') &&
    form.value.discountType == (lastRecord.value?.DiscountType?.identifier || 'Breaks') &&
    form.value.discountTypeId == (lastRecord.value?.DiscountType?.id || 'B')
  ) ? true : false
}

const duplicate = () => {
  router.push(`/materials/discount-schemas/${route.params.id}/duplicate`)
}

const back = () => {
  if(activeSave.value) {
    toast({
      message: 'Save button is active, please submit the data before leaving!',
      type: 'is-warning',
      duration: 2000
    })
  } else {
    router.push('/materials/discount-schemas')
  }
}

const save = async (record) => {
  form.value = record
  setNoEdit()
  if(!noEdit.value) {
    activeSave.value = true
  } else {
    activeSave.value = false
  }
}

const submit = async (saveType = '') => {
  form.value.alert.processing = true
  activeSave.value = true

  const res = await $fetch('/api/materials/discount-schemas/update', {
    method: 'PUT',
    headers: useRequestHeaders(['cookie']),
    body: {
      id: form.value.id,
      organizationId: form.value.organizationId,
      name: form.value.name,
      description: form.value.description,
      isActive: form.value.isActive,
      validFrom: form.value.validFrom,
      isQuantityBased: form.value.isQuantityBased,
      isBPartnerFlatDiscount: form.value.isBPartnerFlatDiscount,
      flatDiscount: form.value.flatDiscount,
      cumulativeLevelId: form.value.cumulativeLevelId,
      discountTypeId: form.value.discountTypeId,
    }
  })

  if(Number(res.status) === 200) {
    form.value.alert.processing = false
    activeSave.value = false
    if(saveType === 'preview') {
      router.push('/materials/discount-schemas/'+res.id+'/view')
    } else if(saveType === 'changes') {
      location.reload()
    } else if(saveType === 'onlysave') {
      toast({
        message: 'Saved!',
        type: 'is-success',
        duration: 2000
      })
      // location.reload()
    } else {
      back()
    }
  } else {
    //form.value.alert.status = res.status
    //form.value.alert.message = res.message
    form.value.alert.processing = false
    activeSave.value = false
    toast({
      message: res.message || 'Save error',
      type: 'is-danger',
      duration: 2000
    })
  }
}

const showAttachment = ref(false)

const breadCrumb = computed(() => ([
  { link: '#', text: 'Materials'},
  { link: '/materials/discount-schemas', text: 'Discount Schemas'},
  { link: '#', text: 'Edit Discount Schema', active: true}
]))
</script>

<template>
  <Head>
    <Title>Edit Discount Schema</Title>
  </Head>

  <NuxtLayout name="new-dash">
    <NewBreadCrumb :items="breadCrumb" />
    
    <div class="bannercontrol">
      <div class="d-flex gap-10px">
        <button type="button" @click="submit('onlysave')" class="button" :class="(form.name === '' || form.cumulativeLevelId === '' || form.discountTypeId === '' || noEdit || form.alert.processing) ? 'pointerEvents-none opacity-0.6' : ''">Save</button>
        <template v-if="form.id !== ''">
          <button type="button" @click="submit" class="button" :class="(form.name === '' || form.cumulativeLevelId === '' || form.discountTypeId === '' || noEdit || form.alert.processing) ? 'pointerEvents-none opacity-0.6' : ''">Save + Exit</button>
          <button type="button" @click="showAttachment = true" class="button" :class="(form.name === '' || form.cumulativeLevelId === '' || form.discountTypeId === '' || form.alert.processing) ? 'pointerEvents-none opacity-0.6' : ''">Attachment</button>
          <button type="button" @click="duplicate" class="button" :class="(!noEdit || form.alert.processing) ? 'pointerEvents-none opacity-0.6' : ''">Duplicate</button>
        </template>
      </div>
      <div>
        <div class="d-flex gap-10px">
          <button v-if="activeSave" type="button" @click="activeSave = false; back();" class="button">
            <span class="tf-icon ti ti-square-x ti-xs me-1 color-inherit"></span> Abort
          </button>
          <button type="button" @click="back" class="button">
            <span class="tf-icon ti ti-chevron-left ti-xs me-1 color-inherit"></span> Back
          </button>
        </div>
      </div>
    </div>

    <div class="banner">
      <div class="editwrapper">
        <MaterialsDiscountSchemaForm v-model="form" @save="save" />
      </div>
      <div v-if="form.discountTypeId === 'B'">
        <MaterialsDiscountSchemaDetailRecord action="edit" :info="form" />
      </div>
      <div>
        <AttachmentModal v-model="showAttachment" target="M_DiscountSchema" :info="form" />
      </div>
    </div>
  </NuxtLayout>
</template>